Gecode::Set::Channel::ChannelSet< View > Class Template Reference
Other available functionality » Set propagators

Propagator for successors/predecessors channelling More...

`#include <channel.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as PC_QUADRATIC_HI).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< CachedView< View > > &x, ViewArray< CachedView< View > > &y)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| ChannelSet (Space &home, ChannelSet &p)
| Constructor for cloning p.
| ChannelSet (Home home, ViewArray< CachedView< View > > &, ViewArray< CachedView< View > > &)
| Constructor for posting.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< CachedView< View > > | xs
| SetViews, reflects the successors of .
ViewArray< CachedView< View > > | ys
| SetViews, reflects the predecessors of .

## Detailed Description

template<typename View>
class Gecode::Set::Channel::ChannelSet< View >

Propagator for successors/predecessors channelling

Implements channelling constraints between 2 sequences of SetVars. For SetVars and SetVars it propagates the constraint . is the set of successors of , and is the set of predecessors of .

Requires

#include <gecode/set/int.hh>
int.hh

Definition at line 226 of file channel.hh.

## Constructor & Destructor Documentation

## ChannelSet() [1/2]

template<typename View>

Gecode::Set::Channel::ChannelSet< View >::ChannelSet | ( | Space & | home,
|  | ChannelSet< View > & | p )

inline protected

Constructor for cloning p.

Definition at line 52 of file set.hpp.

## ChannelSet() [2/2]

template<typename View>

Gecode::Set::Channel::ChannelSet< View >::ChannelSet | ( | Home | home,
|  | ViewArray< CachedView< View > > & | xs0,
|  | ViewArray< CachedView< View > > & | ys0 )

inline protected

Constructor for posting.

Definition at line 38 of file set.hpp.

## Member Function Documentation

## copy()

template<typename View>

Actor * Gecode::Set::Channel::ChannelSet< View >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 101 of file set.hpp.

## cost()

template<typename View>

PropCost Gecode::Set::Channel::ChannelSet< View >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as PC_QUADRATIC_HI).

Implements Gecode::Propagator.

Definition at line 79 of file set.hpp.

## reschedule()

template<typename View>

void Gecode::Set::Channel::ChannelSet< View >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 85 of file set.hpp.

## dispose()

template<typename View>

size_t Gecode::Set::Channel::ChannelSet< View >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 92 of file set.hpp.

## propagate()

template<typename View>

ExecStatus Gecode::Set::Channel::ChannelSet< View >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 107 of file set.hpp.

## post()

template<typename View>

ExecStatus Gecode::Set::Channel::ChannelSet< View >::post | ( | Home | home,
|  | ViewArray< CachedView< View > > & | x,
|  | ViewArray< CachedView< View > > & | y )

inline static

Post propagator for .

Definition at line 60 of file set.hpp.

## Member Data Documentation

## xs

template<typename View>

ViewArray<CachedView<View> > Gecode::Set::Channel::ChannelSet< View >::xs

protected

SetViews, reflects the successors of .

Definition at line 229 of file channel.hh.

## ys

template<typename View>

ViewArray<CachedView<View> > Gecode::Set::Channel::ChannelSet< View >::ys

protected

SetViews, reflects the predecessors of .

Definition at line 231 of file channel.hh.

The documentation for this class was generated from the following files:

- gecode/set/channel.hh
- gecode/set/channel/set.hpp